.686			
.MMX
.model flat, stdcall
option casemap:none
OPTION PROLOGUE:none
OPTION EPILOGUE:none

include j:\masm32\include\windows.inc
include j:\masm32\include\kernel32.inc
include j:\masm32\include\user32.inc
include j:\masm32\include\masm32.inc

include j:\masm32\macros\macros.asm
include j:\masm32\macros\timers.asm

includelib j:\masm32\lib\kernel32.lib
includelib j:\masm32\lib\user32.lib
includelib j:\masm32\lib\masm32.lib


Main        proto

QWtoASCII   proto
DWtoASCII   proto
DW2A        proto


.const

  qwTest1       QWORD 18399999999444444444  ; worst case for IanB code
  qwTest2       QWORD 12345678901234567890  ; no advantage
  qwTest3       QWORD 10000000000999999999  ; best case for IanB code
  qwTest4       QWORD 999999444444444       ; worst case for IanB code
  qwTest5       QWORD 555555123456789       ; no advantage
  qwTest6       QWORD 100000999999999       ; best case for IanB code

  dwTest1       DWORD 3444444444            ; worst case for IanB code
  dwTest2       DWORD 2345678901            ; no advantage
  dwTest3       DWORD 1999999999            ; best case for IanB code
  dwTest4       DWORD 44444                 ; worst case for IanB code
  dwTest5       DWORD 12345                 ; no advantage
  dwTest6       DWORD 99999                 ; best case for IanB code
  dwTest7       DWORD 1


.data

  LOOP_COUNT    EQU	1000000

  fMtStrinG     db "%lu",0
  SzWS          db "wsprintf conversion: ",0
  SzQW          db "QWtoASCII - IanB:    ",0
  SzDW          db "DWtoASCII - PDixon:  ",0

  SzQTest1       db "QWTest 1 - value expected 18399999999444444444",13,10,0
  SzQTest2       db "QWTest 2 - value expected 12345678901234567890",13,10,0
  SzQTest3       db "QWTest 3 - value expected 10000000000999999999",13,10,0
  SzQTest4       db "QWTest 4 - value expected 999999444444444",13,10,0
  SzQTest5       db "QWTest 5 - value expected 555555123456789",13,10,0
  SzQTest6       db "QWTest 6 - value expected 100000999999999",13,10,0

  SzDTest1       db "Test 1 - value expected 3444444444",13,10,0
  SzDTest2       db "Test 2 - value expected 2345678901",13,10,0
  SzDTest3       db "Test 3 - value expected 1999999999",13,10,0
  SzDTest4       db "Test 4 - value expected 44444",13,10,0
  SzDTest5       db "Test 5 - value expected 12345",13,10,0
  SzDTest6       db "Test 6 - value expected 99999",13,10,0
  SzDTest7       db "Test 7 - value expected 1",13,10,0


.data?

align 4

  szBuffer      BYTE  32 dup (?)


.code

Start:
	Invoke	Main
	Invoke	ExitProcess, 0


Main    proc

        push    ebx
        mov     eax, input("Please terminate any high-priority tasks and press ENTER to begin...")
        print   chr$(13,10,13,10,"QWORD to ASCII tests:",13,10,13,10)


        print   addr SzQTest1

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR qwTest1
        mov     edx, DWORD PTR (qwTest1+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest2

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR qwTest2
        mov     edx, DWORD PTR (qwTest2+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest3

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR qwTest3
        mov     edx, DWORD PTR (qwTest3+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest4

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR qwTest4
        mov     edx, DWORD PTR (qwTest4+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest5

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR qwTest5
        mov     edx, DWORD PTR (qwTest5+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest6

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR qwTest6
        mov     edx, DWORD PTR (qwTest6+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   chr$(13,10,13,10,"DWORD to ASCII tests:",13,10,13,10)

 comment    * ------------------------------------------------------------
            Although we don't use it or check it, all 3 routines give the
            same output value in EAX, the number of chars written to the
            output string buffer (not counting the null-termination).
            ------------------------------------------------------------ *

        print   addr SzDTest1

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest1
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest1
        xor     edx, edx        ; clear high DWORD
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzDW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest1
        invoke  DWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest2

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest2
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest2
        xor     edx, edx        ; clear high DWORD
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzDW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest2
        invoke  DWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest3

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest3
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest3
        xor     edx, edx        ; clear high DWORD
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzDW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest3
        invoke  DWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest4

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest4
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest4
        xor     edx, edx        ; clear high DWORD
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzDW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest4
        invoke  DWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest5

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest5
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest5
        xor     edx, edx        ; clear high DWORD
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzDW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest5
        invoke  DWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest6

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest6
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest6
        xor     edx, edx        ; clear high DWORD
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzDW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest6
        invoke  DWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest7

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest7
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest7
        xor     edx, edx        ; clear high DWORD
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzDW
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, dwTest7
        invoke  DWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        mov     eax, input(" Press ENTER to exit...")
        pop     ebx
        ret

Main	EndP

; ------------------------------------------------------------------------------

Align 16

DW2A    proc

    ; -------------------------------------------------------------
    ; "fixed" version of routine from MASM library
    ; return value in EAX should be number of chars written
    ; sadly there appears to be no option to convert a QWORD...
    ; -------------------------------------------------------------
    
    invoke wsprintf, ADDR szBuffer, ADDR fMtStrinG, eax
    ret

DW2A    endp

; ------------------------------------------------------------------------------

Align 16

QWtoASCII    proc

 comment    * ------------------------------------------------------------
            Convert positive QWORD to ASCII string (no sign) by IanB.

            On entry:
                EAX/EDX = value to convert Lo/Hi
            On exit:
                EAX = count of chars written
                ECX = pointer to null-termination byte in output string
                      in case we want to add more chars afterwards
                EDX = original pointer to string buffer
                string buffer contains the null-terminated ASCII string
            EBX/EBP/EDI/ESI preserved
            ------------------------------------------------------------ *

        lea     ecx, szBuffer
        push    ebx
        push    esi
        mov     esi, edx                    ; hold good values in EDI/ESI
        push    edi
        mov     edi, eax
        push    ecx                         ; save value
        mov     bl, "0"
        test    edx, edx                    ; can we skip the slow top DWORD stuff
        jz      TestLowDWORD

        mov     bh, bl                      ; keep for convenience
        cmp     esi, 2H
        jb      Digit09
        jz      Digit10a
        cmp     edx, 17H
        jb      Digit10
        jz      Digit11a
        cmp     esi, 0e8H
        jb      Digit11
        jz      Digit12a
        cmp     edx, 918H
        jb      Digit12
        jz      Digit13a
        cmp     esi, 5af3H
        jb      Digit13
        jz      Digit14a
        cmp     edx, 38d7eH
        jb      Digit14
        jz      Digit15a
        cmp     esi, 2386f2H
        jb      Digit15
        jz      Digit16a
        cmp     edx, 1634578H
        jb      Digit16
        jz      Digit17a
        cmp     esi, 0de0b6b3H
        jb      Digit17
        jz      Digit18a
        cmp     edx, 8ac72304H
        jb      Digit18
        ja      Digit19
        cmp     eax, 89e80000H
        jb      Digit18

Digit19:
        sub     eax, 89e80000H              ; 10,000,000,000,000,000,000
        sbb     edx, 8ac72304H
        add     bl, 1                       ; max value of 19th digit is 1
                                            ; so no need to loop
        mov     edi, eax                    ; copy good values
        mov     esi, edx
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit18

Digit18a:
        cmp     eax, 0a7640000H
        jb      Digit17

Digit18:
        cmp     edx, 45639183H
        jb      @F
        sub     eax, 44f40000H              ; 5,000,000,000,000,000,000
        sbb     edx, 45639182H
        add     bl, 5
        mov     edi, eax                    ; save good values
        mov     esi, edx
@@:
        sub     eax, 0a7640000H             ; 1,000,000,000,000,000,000
        sbb     edx, 0de0b6b3H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     @B
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit17

Digit17a:
        cmp     eax, 5d8a0000H
        jb      Digit16

Digit17:
        cmp     edx, 6f05b5aH
        jb      @F
        sub     eax, 0d3b20000H             ; 500,000,000,000,000,000
        sbb     edx, 6f05b59H
        add     bl, 5
        mov     edi, eax                    ; save good values
        mov     esi, edx
@@:
        sub     eax, 5d8a0000H              ; 100,000,000,000,000,000
        sbb     edx, 1634578H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     @B
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit16

Digit16a:
        cmp     eax, 6fc10000H
        jb      Digit15

Digit16:
        cmp     edx, 0b1a2bdH
        jb      @F
        sub     eax, 2ec50000H              ; 50,000,000,000,000,000
        sbb     edx, 0b1a2bcH
        add     bl, 5
        mov     edi, eax                    ; save good values
        mov     esi, edx
@@:
        sub     eax, 6fc10000H              ; 10,000,000,000,000,000
        sbb     edx, 2386f2H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     @B
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit15

Digit15a:
        cmp     eax, 0a4c68000H
        jb      Digit14

Digit15:
        cmp     edx, 11c37aH
        jb      @F
        sub     eax, 37e08000H              ; 5,000,000,000,000,000
        sbb     edx, 11c379H
        add     bl, 5
        mov     edi, eax                    ; save good values
        mov     esi, edx
@@:
        sub     eax, 0a4c68000H             ; 1,000,000,000,000,000
        sbb     edx, 38d7eH
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     @B
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit14

Digit14a:
        cmp     eax, 107a4000H
        jb      Digit13

Digit14:
        cmp     edx, 1c6c0H
        jb      @F
        sub     eax, 52634000H              ; 500,000,000,000,000
        sbb     edx, 1c6bfH
        add     bl, 5
        mov     edi, eax                    ; save good values
        mov     esi, edx
@@:
        sub     eax, 107a4000H              ; 100,000,000,000,000
        sbb     edx, 5af3H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     @B
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit13

Digit13a:
        cmp     eax, 4e72a000H
        jb      Digit12

Digit13:
        cmp     edx, 2d7aH
        jb      @F
        sub     eax, 883d2000H              ; 50,000,000,000,000
        sbb     edx, 2d79H
        add     bl, 5
        mov     edi, eax                    ; save good values
        mov     esi, edx
@@:
        sub     eax, 4e72a000H              ; 10,000,000,000,000
        sbb     edx, 918H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     @B
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit12

Digit12a:
        cmp     eax, 0d4a51000H
        jb      Digit11

Digit12:
        cmp     edx, 48dH
        jb      @F
        sub     eax, 27395000H              ; 5,000,000,000,000
        sbb     edx, 48cH
        add     bl, 5
        mov     edi, eax                    ; save good values
        mov     esi, edx
@@:
        sub     eax, 0d4a51000H             ; 1,000,000,000,000
        sbb     edx, 0e8H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     @B
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit11

Digit11a:
        cmp     eax, 4876e800H
        jb      Digit10

Digit11:
        cmp     edx, 75H
        jb      @F
        sub     eax, 6a528800H              ; 500,000,000,000
        sbb     edx, 74H
        add     bl, 5
        mov     edi, eax                    ; save good values
        mov     esi, edx
@@:
        sub     eax, 4876e800H              ; 100,000,000,000
        sbb     edx, 17H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     @B
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit10

Digit10a:
        cmp     eax, 540be400H
        jb      Digit09

Digit10:
        cmp     edx, 0cH
        jb      @F
        sub     eax, 0a43b7400H             ; 50,000,000,000
        sbb     edx, 0bH
        add     bl, 5
        mov     edi, eax                    ; save good values
        mov     esi, edx
@@:
        sub     eax, 540be400H              ; 10,000,000,000
        sbb     edx, 2H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     @B
@@:
        mov     eax, edi                    ; copy good value to test
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1

Digit09:
        mov     edx, 1                      ; convenience number
        test    esi, esi
        jz      @F
        sub     eax, 0ee6b2800H             ; 4,000,000,000
        sbb     esi, 0
        add     bl, 4
        mov     edi, eax                    ; save good value
@@:
        sub     eax, 1000000000
        sbb     esi, 0
        jb      @F
        add     bl, dl
        mov     edi, eax                    ; save good value
        jmp     @B

TestLowDWORD:
        mov     edx, 1                      ; convenience number
        cmp     eax, 10
        jb      Digit00
        cmp     edi, 100
        jb      Digit01
        cmp     eax, 1000
        jb      Digit02
        cmp     edi, 10000
        jb      Digit03
        cmp     eax, 100000
        jb      Digit04
        cmp     edi, 1000000
        jb      Digit05
        cmp     eax, 10000000
        jb      Digit06
        cmp     edi, 100000000
        jb      Digit07
        sub     eax, 1000000000
        jb      Digit08

Digit09a:
        mov     edi, eax                    ; save good value, no high DWORD
        add     bl, dl
        sub     eax, 1000000000             ; only 3 iterations of this loop max
        jae     Digit09a
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit08:
        mov     eax, (-900000000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop08
@@:
        sub     esi, 100000000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 100000000
        mov     edi, esi                    ; save good value
        js      @B

FromTop08:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit07:
        mov     eax, (-90000000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop07
@@:
        sub     esi, 10000000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 10000000
        mov     edi, esi                    ; save good value
        js      @B

FromTop07:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit06:
        mov     eax, (-9000000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop06
@@:
        sub     esi, 1000000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 1000000
        mov     edi, esi                    ; save good value
        js      @B

FromTop06:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit05:
        mov     eax, (-900000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop05
@@:
        sub     esi, 100000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 100000
        mov     edi, esi                    ; save good value
        js      @B

FromTop05:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit04:
        mov     eax, (-90000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop04
@@:
        sub     esi, 10000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 10000
        mov     edi, esi                    ; save good value
        js      @B

FromTop04:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit03:
        mov     eax, (-9000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop03
@@:
        sub     esi, 1000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 1000
        mov     edi, esi                    ; save good value
        js      @B

FromTop03:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit02:
        mov     eax, (-900)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop02
@@:
        sub     esi, 100
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 100
        mov     edi, esi                    ; save good value
        js      @B

FromTop02:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit01:
        mov     esi, (-90)
        mov     bl, "0"
        mov     bh, "9"
        add     esi, edi                    ; check if digit = 9
        jns     FromTop01
@@:
        mov     eax, edi                    ; save good value
        sub     edi, 10
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     esi, 10
        js      @B

FromTop01:
        mov     bl, bh
        mov     eax, esi                    ; copy good final digit
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit00:
        add     al, "0"
        mov     ebx, edx                    ; EBX = 1
        pop     edx                         ; retrieve original string pointer
        mov     [ecx], ax                   ; add null-termination
        add     ecx, ebx                    ; point to null-termination byte
        pop     edi
        mov     eax, ecx
        pop     esi
        sub     eax, edx                    ; get count of chars written
        pop     ebx
        ret

QWtoASCII endp

; ------------------------------------------------------------------------------

Align 16

DWtoASCII    proc
        
 comment    * ------------------------------------------------------------
            Convert positive DWORD to ASCII string (no sign) by Paul Dixon
            with minor additions by IanB

            On entry:
                EAX = value to convert
            On exit:
                EAX = number of chars written
                NumText buffer contains the ASCII string representation,
                null-terminated.
            EBX/EBP/EDI/ESI preserved
            ------------------------------------------------------------ *

        push    ebx
        push    edi
        push    eax                 ; save absolute value of number
                                    ; call it 1234567890
        mov     ecx, 2814749768
        lea     edi, szBuffer       ; pointer to answer string

        mul     ecx                 ; fast div by 100000
        mov     ecx, 100000         ; prepare to multiply up the top 5 digits
        shr     edx, 16             ; shift top 5 digits into place, EDX=12345
        mov     eax, edx            ; copy to eax to multiply up to real size again
        mov     ebx, edx            ; save a copy of top 5 digits
        mul     ecx                 ; EAX=1234500000
        sub     [esp], eax          ; sub from original number leaves 0000067890

        mov     eax, ebx            ; get back high digits
        mov     ecx, 429497         ; about to do div 10000 by reciprocal multiply
        mov     ebx, 10

        or      eax, eax            ; if top 5 digit = 0 then skip that part
        jz      SkipTop5

        mul     ecx                 ; div top 5 digits by 10000
        jc      digit1              ; if digit is not zero then process it
        mul     ebx                 ; else multiply by 10 to get next digit into EDX
        jc      digit2
        mul     ebx
        jc      digit3
        mul     ebx
        jc      digit4
        mul     ebx
        jc      digit5

SkipTop5:
        pop     eax                 ; retrieve lower 5 digits
        mul     ecx                 ; div 10000
        jc      digit6
        mul     ebx                 ; multiply by 10 to get next digit in EDX
        jc      digit7
        mul     ebx
        jc      digit8
        mul     ebx
        jc      digit9
        mul     ebx
        jmp     digit10

digit1:
        add     edx, 30h            ; top digit is left in EDX, convert to ascii
        mov     [edi], dl           ; store top digit
        mul     ebx                 ; multiply by 10 to get next digit into EDX
        add     edi, 1

digit2:
        add     edx, 30h
        mov     [edi], dl
        mul     ebx
        add     edi, 1

digit3:
        add     edx, 30h
        mov     [edi], dl
        mul     ebx
        add     edi, 1

digit4:
        add     edx, 30h
        mov     [edi], dl
        mul     ebx
        add     edi, 1

digit5:
        add     edx, 30h
        mov     [edi], dl

        pop     eax                 ; retrieve lower 5 digits
        mul     ecx                 ; div 10000
        add     edi, 1

digit6:
        add     edx, 30h
        mov     [edi], dl
        mul     ebx
        add     edi, 1

digit7:
        add     edx, 30h
        mov     [edi], dl
        mul     ebx
        add     edi, 1

digit8:
        add     edx, 30h
        mov     [edi], dl
        mul     ebx
        add     edi, 1

digit9:
        add     edx, 30h
        mov     [edi], dl
        mul     ebx
        add     edi, 1

digit10:
        add     edx, 30h
        lea     eax, szBuffer       ; return buffer pointer
        mov     [edi], dx           ; last digit, store DX not DL to give a 
                                    ; zero termination for the result string
        sub     eax, edi
        pop     edi
        sub     eax, 1
        pop     ebx
        neg     eax                 ; return number of chars written
        ret

DWtoASCII    endp


End	Start
